SystemOrganization addCategory: #LazyRabbit!
SystemOrganization addCategory: 'LazyRabbit-PureTest'!
SystemOrganization addCategory: 'LazyRabbit-abstract'!
SystemOrganization addCategory: 'LazyRabbit-concrete'!

TestCase subclass: #LazyRabbitOperationTest
	instanceVariableNames: 'op'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

LazyRabbitOperationTest subclass: #LROAddInstVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

!LROAddInstVarTest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:53'!
isAbstract 
	^false! !

!LROAddInstVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:02'!
setUp
	super setUp.
	op := LROAddInstVar new.! !

!LROAddInstVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:06'!
testAlreadyExist
	op subjectClass: Object.
	op variableName: 'bounds'.
	self deny: op alreadyExist.
	
	op subjectClass: Morph.
	self assert: op alreadyExist.! !

LazyRabbitOperationTest subclass: #LROCompileDefaultTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

!LROCompileDefaultTest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:53'!
isAbstract 
	^false! !

!LROCompileDefaultTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:02'!
setUp
	super setUp.
	op := LROCompileDefault new.! !

!LROCompileDefaultTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 23:59'!
testAlreadyExist
	op subjectClass: Object.
	op variableName: 'is'.
	self deny: op alreadyExist.
	
	op subjectClass: PluggableButtonMorph.
	self assert: op alreadyExist.! !

!LROCompileDefaultTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:16'!
testMethodCategory
	self assert: op methodCategory equals: 'defaults'! !

!LROCompileDefaultTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 23:43'!
testMethodSelector
	op variableName: 'john'.
	self assert: op selector equals: 'johnDefault'! !

!LROCompileDefaultTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 23:43'!
testSourceCode
	op variableName: 'foo'.
	self assert: op sourceCode equals:
'fooDefault

	^self shouldBeImplemented'! !

LazyRabbitOperationTest subclass: #LROCompileGetterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

!LROCompileGetterTest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:53'!
isAbstract 
	^false! !

!LROCompileGetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:03'!
setUp
	super setUp.
	op :=  LROCompileGetter new.! !

!LROCompileGetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:06'!
testAlreadyExist
	op subjectClass: Object.
	op variableName: 'bounds'.
	self deny: op alreadyExist.
	
	op subjectClass: Morph.
	self assert: op alreadyExist.! !

!LROCompileGetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:15'!
testMethodCategory
	self assert: op methodCategory equals: 'accessing'! !

!LROCompileGetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:17'!
testMethodSelector
	op variableName: 'john'.
	self assert: op selector equals: 'john'! !

!LROCompileGetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/22/2014 23:44'!
testSourceCode
	op variableName: 'foo'.
	self assert: op sourceCode equals:
'foo

	^foo setDefault: #fooDefault for: self withSetter: #foo:'! !

LazyRabbitOperationTest subclass: #LROCompileSetterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

!LROCompileSetterTest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:53'!
isAbstract 
	^false! !

!LROCompileSetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:03'!
setUp
	super setUp.
	op :=   LROCompileSetter new.! !

!LROCompileSetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:06'!
testAlreadyExist
	op subjectClass: Object.
	op variableName: 'bounds'.
	self deny: op alreadyExist.
	
	op subjectClass: Morph.
	self assert: op alreadyExist.! !

!LROCompileSetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:15'!
testMethodCategory
	self assert: op methodCategory equals: 'accessing'! !

!LROCompileSetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:17'!
testMethodSelector
	op variableName: 'john'.
	self assert: op selector equals: 'john:'! !

!LROCompileSetterTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/11/2013 03:20'!
testSourceCode
	op variableName: 'foo'.
	self assert: op sourceCode equals:
'foo: anObject
		
	foo := anObject'! !

!LazyRabbitOperationTest class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/20/2013 12:52'!
isAbstract 
	^true! !

TestCase subclass: #VariableNameIsCorrectTest
	instanceVariableNames: 'op'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-PureTest'!

!VariableNameIsCorrectTest methodsFor: 'running' stamp: 'HwaJong 1/11/2013 03:10'!
setUp
	super setUp.
	op := LazyRabbitOperation new.! !

!VariableNameIsCorrectTest methodsFor: 'tests' stamp: 'HwaJong 1/11/2013 03:11'!
testEmpty
	op variableName: ''.
	self deny: op variableNameIsCorrect.
	
	op variableName: 'normal'.
	self assert: op variableNameIsCorrect.! !

!VariableNameIsCorrectTest methodsFor: 'tests' stamp: 'HwaJong 1/11/2013 03:11'!
testNil
	op variableName: nil.
	self deny: op variableNameIsCorrect.
	
	op variableName: 'normal'.
	self assert: op variableNameIsCorrect.! !

!VariableNameIsCorrectTest methodsFor: 'tests' stamp: 'HwaJong 1/11/2013 03:12'!
testStartsWithUppercase
	op variableName: 'Normal'.
	self deny: op variableNameIsCorrect.
	
	op variableName: 'normal'.
	self assert: op variableNameIsCorrect.! !

!Browser methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 13:57'!
createLazyRabbitVar

	LazyRabbitOperation variableNameFromUserAndSubjectClass: self selectedClass.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 14:02'!
addLazyRabbitInstVar: aString
	LazyRabbitOperation subjectClass: self variableName: aString.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 15:17'!
addLazyRabbitInstVarFromUser
	LazyRabbitOperation variableNameFromUserAndSubjectClass: self.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 14:05'!
carelesslyRemoveLazyRabbitInstVar: aString
	LazyRabbitOperation carelesslyRemoveVariableName: aString subjectClass: self.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 15:17'!
carelesslyRemoveLazyRabbitInstVarFromUser
	LazyRabbitOperation carelesslyRemoveVariableNameFromUserAndSubjectClass: self.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 2/4/2013 14:51'!
instanceCreator: anArray 
	"MyClass instanceCreator: #(hello world)"
	|pairs|
	pairs := OrderedCollection new.
	anArray keysAndValuesDo: [:index :keyword|
		pairs addLast: (keyword, ': object', index printString)
	].
	^self instanceCreatorWithPairs: pairs.
! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 2/4/2013 14:52'!
instanceCreatorWithPairs: anArray 
	"MyClass instanceCreatorWithPairs: {'hello: anInteger'. 'world: aBoolean'. 'sun: aString'}"
	|code|
	code := String streamContents: [:stream |
		anArray do: [:p| stream nextPutAll: p; space].
		stream cr.
		stream tab.
		stream nextPutAll: '^self new'.
		stream cr.
		anArray do: [:p| stream tab;tab; nextPutAll: p; nextPut: $;; cr].
		stream tab;tab; nextPutAll: 'yourself'.
		].
	self class compile: code classified: 'instance creation' notifying: nil.! !

!Class methodsFor: '*LazyRabbit' stamp: 'HwaJong 2/4/2013 14:53'!
instanceCreatorWithSignature: aString 
	"MyClass instanceCreatorWithSignature: 'hello: anInteger world: aBoolean sun: aString'"
	| parsed pairs |
	parsed := RBParser parseMethod: aString.
	pairs := (parsed selectorParts collect: #value) with: (parsed arguments collect: [:each| each token value]) 
		collect: [:keyword :argument| 
			String streamContents: [:stream|
				stream nextPutAll: keyword.
				stream space.
				stream nextPutAll: argument]].
	^self instanceCreatorWithPairs: pairs.! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 9/20/2009 15:18'!
ifNilInitializeWith: initializingSelector in: anObject 

	| newObject |
	newObject := anObject perform: initializingSelector.
	self assert: [newObject notNil] description: 'Initialized but it''s still nil.'.
	"Make sure your initializingSelector sets anObject's instance variable."
	^newObject! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	| default |
	default := anObject perform: defaultSymbol.
	anObject perform: setter with: default.
	^default! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'HwaJong 6/10/2013 12:10'!
setDefault: defaultGenerator for: anObject withSetter: setter afterSetOperation: afterOp 
	[^self setDefault: defaultGenerator for: anObject withSetter: setter] ensure: [anObject perform: afterOp] ! !

!MessageNotUnderstood methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/12/2013 14:09'!
createLazyRabbitVar
	self assert: [message numArgs = 0].
	receiver class addLazyRabbitInstVar: message selector! !

!ByteString methodsFor: '*LazyRabbit' stamp: 'HwaJong 1/11/2013 11:27'!
isValidInstanceVariableName
	^self isEmpty not and: [self first isLowercase] ! !

Object subclass: #LazyRabbitOperation
	instanceVariableNames: 'subjectClass variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-abstract'!

LazyRabbitOperation subclass: #LROAddInstVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-concrete'!

!LROAddInstVar methodsFor: 'testing' stamp: 'HwaJong 1/11/2013 00:22'!
alreadyExist

	^subjectClass instVarNames includes: variableName! !

!LROAddInstVar methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:15'!
alreadyExistOperation
	^true! !

!LROAddInstVar methodsFor: 'private' stamp: 'HwaJong 1/11/2013 00:05'!
kukwakwakwa
	subjectClass addInstVarNamed: variableName! !

!LROAddInstVar methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:21'!
notExistOperation
	self kukwakwakwa.
	^true! !

!LROAddInstVar methodsFor: 'private' stamp: 'HwaJong 1/11/2013 11:54'!
zaaap
	subjectClass removeInstVarNamed: variableName! !

LazyRabbitOperation subclass: #LROCompileMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-abstract'!

LROCompileMethod subclass: #LROCompileAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-abstract'!

!LROCompileAccessor methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:37'!
alreadyExistAndUserWantsToOverwriteOperation
	self kukwakwakwa.
	^true! !

!LROCompileAccessor methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:26'!
methodCategory
	^'accessing'! !

!LROCompileAccessor methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:57'!
notExistOperation
	self kukwakwakwa.
	^true! !

LROCompileAccessor subclass: #LROCompileGetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-concrete'!

!LROCompileGetter methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:20'!
selector

	^variableName asSymbol! !

!LROCompileGetter methodsFor: 'self evaluating' stamp: 'HwaJong 1/22/2014 23:46'!
sourceCode
	
	^variableName ,
'

	^',variableName,' setDefault: #', variableName ,'Default for: self withSetter: #',variableName,':'! !

LROCompileAccessor subclass: #LROCompileSetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-concrete'!

!LROCompileSetter methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:20'!
selector

	^(variableName , ':') asSymbol! !

!LROCompileSetter methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:19'!
sourceCode

	^variableName ,': anObject
		
	',variableName,' := anObject'! !

LROCompileMethod subclass: #LROCompileDefault
	instanceVariableNames: 'returningExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit-concrete'!

!LROCompileDefault methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:32'!
alreadyExistAndUserWantsToOverwriteOperation
	self smartSetReturningExpression: (UIManager default request: 'default expression' initialAnswer: '3+4').
	self kukwakwakwa.
	^true! !

!LROCompileDefault methodsFor: 'initialize-release' stamp: 'HwaJong 1/11/2013 02:39'!
initialize 
	super initialize.
	self initializeReturningExpression! !

!LROCompileDefault methodsFor: 'initialization' stamp: 'HwaJong 1/11/2013 00:54'!
initializeReturningExpression
	returningExpression := 'self shouldBeImplemented'! !

!LROCompileDefault methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:08'!
methodCategory
	^'defaults'! !

!LROCompileDefault methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 03:22'!
notExistOperation
	^self privateOperation! !

!LROCompileDefault methodsFor: 'private' stamp: 'HwaJong 4/20/2013 13:24'!
privateOperation

	self smartSetReturningExpression: 
		(UIManager default 
			multiLineRequest: 'default expression for ', variableName printString
			initialAnswer: '3+4'
			answerHeight: 150).
	self kukwakwakwa.
	^true! !

!LROCompileDefault methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:10'!
returningExpression
	^ returningExpression! !

!LROCompileDefault methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:10'!
returningExpression: aString
	returningExpression := aString
! !

!LROCompileDefault methodsFor: 'self evaluating' stamp: 'HwaJong 1/22/2014 23:45'!
selector

	^(variableName, 'Default') asSymbol! !

!LROCompileDefault methodsFor: 'properties' stamp: 'HwaJong 1/11/2013 00:55'!
smartSetReturningExpression: aString 
	aString ifNil: [^self initializeReturningExpression].
	aString isEmpty ifTrue: [^self initializeReturningExpression].
	(aString beginsWith: '^')
		ifTrue: [returningExpression := aString allButFirst. ^self].
	returningExpression := aString! !

!LROCompileDefault methodsFor: 'self evaluating' stamp: 'HwaJong 1/22/2014 23:46'!
sourceCode

	^variableName , 'Default

	^', returningExpression! !

!LROCompileMethod methodsFor: 'testing' stamp: 'HwaJong 1/11/2013 00:24'!
alreadyExist

	^subjectClass selectors includes: self selector! !

!LROCompileMethod methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:39'!
alreadyExistAndUserDontWantToOverwriteOperation
	^true! !

!LROCompileMethod methodsFor: 'user interactions' stamp: 'HwaJong 1/11/2013 02:46'!
alreadyExistOperation
	^(UIManager default confirm: 
'Method already exist.
Do you want to overwrite?' label: self selector printString)
		ifTrue: [self alreadyExistAndUserWantsToOverwriteOperation]
		ifFalse: [self alreadyExistAndUserDontWantToOverwriteOperation]! !

!LROCompileMethod methodsFor: 'private' stamp: 'HwaJong 1/11/2013 02:17'!
kukwakwakwa 
	subjectClass compile: self sourceCode
			classified: self methodCategory notifying: nil! !

!LROCompileMethod methodsFor: 'self evaluating' stamp: 'HwaJong 1/11/2013 00:41'!
sourceCodeOfRealMethod
	^(subjectClass sourceCodeAt: self selector) asString! !

!LROCompileMethod methodsFor: 'private' stamp: 'HwaJong 1/11/2013 11:54'!
zaaap
	subjectClass removeSelector: self selector ! !

!LazyRabbitOperation class methodsFor: 'remove' stamp: 'HwaJong 1/11/2013 11:54'!
carelesslyRemoveVariableName: aString subjectClass: aClass
	(self operationsInOrderWithSubjectClass: aClass variableName: aString) reverse do: #zaaap! !

!LazyRabbitOperation class methodsFor: 'remove' stamp: 'HwaJong 1/11/2013 12:01'!
carelesslyRemoveVariableNameFromUserAndSubjectClass: aClass 
	| ivars ivarIndex |
	ivars := aClass allInstVarNames.
	ivarIndex := UIManager default chooseFrom: ivars title: 'LazyRabbit: instance variable to delete'.
	ivarIndex >= 1 ifTrue: [self carelesslyRemoveVariableName: (ivars at: ivarIndex) subjectClass: aClass]	! !

!LazyRabbitOperation class methodsFor: 'private' stamp: 'HwaJong 1/11/2013 11:47'!
operationsInOrderWithSubjectClass: aClass variableName: aString
	^{LROAddInstVar. LROCompileSetter. LROCompileDefault. LROCompileGetter}
		collect: [:opClass| (opClass new subjectClass: aClass; variableName: aString) ]! !

!LazyRabbitOperation class methodsFor: 'add' stamp: 'HwaJong 1/11/2013 11:49'!
subjectClass: aClass variableName: aString
	(self operationsInOrderWithSubjectClass: aClass variableName: aString) do: #managedProcess! !

!LazyRabbitOperation class methodsFor: 'add' stamp: 'HwaJong 1/11/2013 11:25'!
variableNameFromUserAndSubjectClass: aClass
	| newVarName |
	newVarName := UIManager default request: 'New instance variable name?' initialAnswer: '' title: 'LazyRabbit'.
	newVarName isValidInstanceVariableName
		ifTrue: [self subjectClass: aClass variableName: newVarName]! !

!LazyRabbitOperation methodsFor: 'testing' stamp: 'HwaJong 1/11/2013 00:23'!
alreadyExist
	"boolean"
	^self subclassResponsibility.! !

!LazyRabbitOperation methodsFor: 'private' stamp: 'HwaJong 1/11/2013 00:23'!
kukwakwakwa
	self subclassResponsibility.! !

!LazyRabbitOperation methodsFor: 'public' stamp: 'HwaJong 1/11/2013 02:15'!
managedProcess
	^self alreadyExist
		ifTrue: [ self alreadyExistOperation ]
		ifFalse: [self notExistOperation ] ! !

!LazyRabbitOperation methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:06'!
subjectClass
	^ subjectClass! !

!LazyRabbitOperation methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:06'!
subjectClass: aClass
	subjectClass := aClass
! !

!LazyRabbitOperation methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:06'!
variableName
	^ variableName! !

!LazyRabbitOperation methodsFor: 'accessing' stamp: 'HwaJong 1/11/2013 00:06'!
variableName: aString
	variableName := aString
! !

!LazyRabbitOperation methodsFor: 'testing' stamp: 'HwaJong 1/11/2013 03:12'!
variableNameIsCorrect
	^variableName notNil and: [variableName size > 0 and: [variableName first isLowercase]]! !

!LazyRabbitOperation methodsFor: 'private' stamp: 'HwaJong 1/11/2013 11:54'!
zaaap
	self subclassResponsibility.! !

!Object methodsFor: '*LazyRabbit' stamp: 'hjo 9/20/2009 15:04'!
ifNilInitializeWith: initializingSelector in: anObject

	"no need to initialize."
	^self! !

!Object methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	"I am not nil, so do nothing."
	^self! !

!Object methodsFor: '*LazyRabbit' stamp: 'HwaJong 6/10/2013 12:11'!
setDefault: defaultGenerator for: anObject withSetter: setter afterSetOperation: afterOp 
	^self! !
